package pen_flowchart;

import java.awt.Color;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Point;
//import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.geom.Rectangle2D;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

//import com.itextpdf.text.pdf.PdfContentByte;


public class Parts_If extends Parts {
	private Parts_Null parts_endif;
	int text_width, text_height;
	int left_width, right_width;
	int v_margin, h_margin;
	int dx;
//	private Rectangle frame;

	public Parts_If()
	{
		super();
		setValue("≪条件≫");
		right = empty;
		text_width = text_height = 0;
		left_width = right_width = 10;
		v_margin = 10;
		h_margin = 10;
	}

	public void setValue(String s)
	{
		setText(s);
	}

	public void setEndif(Parts_Null p)
	{
		parts_endif = p;
	}

	@Override
	public Parts getBlockEnd()
	{
		return parts_endif;
	}

	@Override
	public boolean isRecursiveBegin()
	{
		return true;
	}

	@Override
	public int getHeight() {
		return text_height + v_margin * 2;
	}

	@Override
	public int getWidth() {
		return text_width + h_margin * 2;
	}

	@Override
	public Parts paint(Graphics g, FontMetrics fm, Point p) {
//		g.setColor(Color.LIGHT_GRAY);
//		g.drawRect(p.x + frame.x - 2, p.y + frame.y -2 , frame.width + 4, frame.height + 4);
		setX1(p.x - getWidth() / 2);
		setX2(p.x + getWidth() / 2);
		setY1(p.y);
		setY2(p.y + getHeight());
		int ym = p.y + getHeight() / 2;
		int x[] = {p.x, getX1(), p.x, getX2()};
		int y[] = {p.y, ym, getY2(), ym};
		g.setColor(Color.WHITE);
		g.fillPolygon(x,y,4);
		g.setColor(Color.BLACK);
//g.drawString(Integer.toString(dx), p.x, p.y);
		drawString(getText(),g,fm,getX1(),getY1(),getX2(),getY2());
		g.drawPolygon(x, y, 4);
		// 左側
		g.drawString("Y", getX1() - 6, ym - 4);
//g.drawString(Integer.toString(getX1()),getX1() - 12, ym - 2);
//g.drawString(Integer.toString(left_width),getX1() - 12, ym +10);
		Point p1 = new Point(getX1() - left_width / 2, ym);
//g.drawString(Integer.toString(p1.x),p1.x - 12, ym +20);
		g.drawLine(getX1(), ym, p1.x, ym);
		Parts pLeft = getLeft().paint(g, fm, p1);
		// 右側
		g.drawString("N", getX2(), ym - 4);
//g.drawString(Integer.toString(getX2()), getX2(), ym - 2);
//g.drawString(Integer.toString(right_width), getX2(), ym + 10);
		Point p2 = new Point(getX2() + right_width / 2 + dx, ym);
//g.drawString(Integer.toString(p2.x), p2.x, ym + 20);
		g.drawLine(getX2(), ym, p2.x, ym);
		Parts pRight = getRight().paint(g, fm, p2);
		// まとめ
		if(p1.y > p2.y)
		{
			p.y = p1.y;
			pRight.setY2(p.y);
		}
		else
		{
			p.y = p2.y;
			pLeft.setY2(p.y);
		}
		g.drawLine(p1.x, p1.y, p1.x, p.y);
		g.drawLine(p1.x, p.y, p.x, p.y);
		g.drawLine(p2.x, p2.y, p2.x, p.y);
		g.drawLine(p2.x, p.y, p.x, p.y);

		return pLeft.getLeft().paint(g, fm, p);
	}
/*
  	@Override

	public Parts paintPdf(PdfContentByte cb, int height, Graphics g,
			FontMetrics fm, Point p) {
		setX1(p.x - getWidth() / 2);
		setX2(p.x + getWidth() / 2);
		setY1(p.y);
		setY2(p.y + getHeight());
		int ym = p.y + getHeight() / 2;
		int x[] = {p.x, getX1(), p.x, getX2()};
		int y[] = {p.y, ym, getY2(), ym};
		g.setColor(Color.WHITE);
		g.fillPolygon(x,y,4);
		g.setColor(Color.BLACK);
		drawStringPdf(cb, height, getText(),g,fm,getX1(),getY1(),getX2(),getY2());
		g.drawPolygon(x, y, 4);
		// 左側
		g.drawString("Y", getX1() - 6, ym - 4);
		Point p1 = new Point(getX1() - left_width / 2, ym);
		g.drawLine(getX1(), ym, p1.x, ym);
		Parts pLeft = getLeft().paintPdf(cb, height, g, fm, p1);
		// 右側
		g.drawString("N", getX2(),ym - 4);
		Point p2 = new Point(getX2() + right_width / 2 + dx, ym);
		g.drawLine(getX2(), ym, p2.x, ym);
		Parts pRight = getRight().paintPdf(cb, height, g, fm, p2);
		// まとめ
		if(p1.y > p2.y)
		{
			p.y = p1.y;
			pRight.setY2(p.y);
		}
		else
		{
			p.y = p2.y;
			pLeft.setY2(p.y);
		}
		g.drawLine(p1.x, p1.y, p1.x, p.y);
		g.drawLine(p1.x, p.y, p.x, p.y);
		g.drawLine(p2.x, p2.y, p2.x, p.y);
		g.drawLine(p2.x, p.y, p.x, p.y);

		return pLeft.getLeft().paintPdf(cb, height, g, fm, p);
	}
*/
	@Override
	public void setSize(Graphics g, FontMetrics fm) {
		text_width = text_height = 0;
		if(getText() != null)
		{
			Rectangle2D rect = fm.getStringBounds(getText(), g);
			text_width = (int)rect.getWidth();
			text_height = (int)rect.getHeight();
		}
		if(text_width < size * 6) text_width = size * 6;
		if(text_height < size * 2) text_height = size * 2;
		v_margin = size * 2;
		h_margin = text_width * text_height / v_margin / 4;
	}

	@Override
	public Parts calcSize(Graphics g, FontMetrics fm, Point p, Point p1, Point p2)
	{
		dx = 0;
		setSize(g, fm);
		int x1 = p.x - getWidth() / 2 ;
		int x2 = p.x + getWidth() / 2 ;
		// 左側
		Point pl = new Point(x1, p.y);
		Point pl1 = new Point(pl);
		Point pl2 = new Point(pl);
		Parts pLeft = getLeft().calcSize(g, fm, pl, pl1, pl2);
		left_width = (pl2.x - pl.x) * 2 - getWidth() / 2;
		if(left_width < 10) left_width = 10;
		pl1.x -= left_width / 2;
		pl2.x -= left_width / 2;
		if(pl1.x < p1.x) p1.x = pl1.x;
		if(pl2.y > p2.y) p2.y = pl2.y;
		// 右側
		Point pr = new Point(x2, p.y);
		Point pr1 = new Point(pr);
		Point pr2 = new Point(pr);
		getRight().calcSize(g, fm, pr, pr1, pr2);
		right_width = (pr.x - pr1.x) * 2 - getWidth() / 2;
		if(right_width < 10) right_width = 10;
		pr1.x += right_width / 2;
		pr2.x += right_width / 2;
		if(pr1.x < pl2.x) // 重なってしまうので右の枝をずらす
			dx = pl2.x - pr1.x ;
		if(pr2.x > p2.x) p2.x = pr2.x;
		if(pr2.y > p2.y) p2.y = pr2.y;
		// まとめ
//		int prev_py = p.y;
		p2.y = p.y = (p1.y > p2.y ? p1.y : p2.y) + getHeight() / 2;
//		int prev_p2y = p2.y;
		p1.x -= 2; p2.x += 2;
		Parts rtnv = pLeft.getLeft().calcSize(g, fm, p, p1, p2);
//		frame = new Rectangle(pl1.x - p.x, pl1.y - prev_py, pr2.x - pl1.x, prev_p2y - prev_py);
		return rtnv;
	}

	@Override
	public Parts appendTo(StringBuilder sb, int indentLevel) {
		Parts pNext = this;
		makeIndent(sb, indentLevel);
		sb.append("もし " + getText() + " ならば\n");
		if(getLeft() != null)
		{
			pNext = getLeft().appendTo(sb, indentLevel + 1);
			if(getLeft().getLeft().isRecursiveEnd())
			{
				makeIndent(sb, indentLevel + 1);
				sb.append("\n");
			}
		}
		if(!getRight().getLeft().isRecursiveEnd())
		{
			makeIndent(sb, indentLevel);
			sb.append("を実行し，そうでなければ\n");
			pNext = getRight().appendTo(sb, indentLevel + 1);
			if(getRight().getLeft().isRecursiveEnd())
			{
				makeIndent(sb, indentLevel + 1);
				sb.append("\n");
			}
		}
		makeIndent(sb, indentLevel);
		sb.append("を実行する\n");
		return pNext.getLeft().appendTo(sb, indentLevel);
	}

	@Override
	public boolean deleteMe(Flowchart chart)
	{
		Parts parent = chart.findParent(this);
		parent.setLeft(parts_endif.left.left);
		return true;
	}


	@Override
	public boolean editMe()
	{
		EditDialog dialog = new EditDialog();
		dialog.setVisible(true);
		return isDirty();
	}

	private class EditDialog extends MyDialog
	{
		private static final long serialVersionUID = 1L;
		JButton btnOK, btnCancel;
		JTextField text;

		public EditDialog() {
			super();
			this.setTitle("分岐の編集");
			JPanel panel = new JPanel();
			panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
			text = new JTextField(40);
			grabFocus(text);
			text.setText(getText());
			btnOK = new JButton("OK");
			btnOK.addActionListener(this);
			getRootPane().setDefaultButton(btnOK);
			btnCancel = new JButton("キャンセル");
			btnCancel.addActionListener(this);
			panel.add(new JLabel("条件"));
			panel.add(text);
			panel.add(btnOK);
			panel.add(btnCancel);
			getContentPane().add(panel);
			pack();
			setLocationRelativeTo(null);
		}

		@Override
		public void actionPerformed(ActionEvent e) {
			if(e.getSource() == btnOK)
			{
				setText(Converter.Zen2Han(text.getText()));
				makeDirty();
				dispose();
			}
			else if(e.getSource() == btnCancel)
				dispose();
		}
	}

	@Override
	Parts makeXML(Document doc, Element parent) {
		Element elem = doc.createElement("if");
		Element child_then = doc.createElement("then");
		Element child_else = doc.createElement("else");
		elem.setAttribute("condition", getText());

		Parts parts_end = left.makeXML(doc, child_then);
		right.makeXML(doc, child_else);
		elem.appendChild(child_then);
		elem.appendChild(child_else);
		parent.appendChild(elem);

		if(parts_end.getLeft() != empty)// && !parts_end.getLeft().isRecursiveEnd())
			return parts_end.getLeft().getLeft().makeXML(doc, parent);
		return parts_end.getLeft();
	}


}
