package pen_flowchart;

import java.awt.Color;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.event.MouseEvent;
import java.awt.geom.Rectangle2D;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

//import com.itextpdf.text.pdf.PdfContentByte;

public class Parts_Terminal extends Parts {
	int text_width, text_height;

	@Override
	public int getHeight() {
		return text_height + size * 2;
	}

	@Override
	public int getWidth() {
		return text_width + getHeight();
	}

	@Override
	public Parts paint(Graphics g, FontMetrics fm, Point p) {
		setX1(p.x - getWidth() / 2);
		setX2(p.x + getWidth() / 2);
		setY1(p.y);
		setY2(p.y + getHeight());
		g.setColor(Color.WHITE);
		g.fillRect(p.x - text_width / 2, p.y, text_width + 1, getHeight());
		g.fillArc(p.x + text_width / 2 - getHeight() / 2, p.y, getHeight(), getHeight(), -90, 180);
		g.fillArc(p.x - text_width / 2 - getHeight() / 2, p.y, getHeight(), getHeight(), 90, 180);
		g.setColor(Color.BLACK);
		drawString(getText(),g,fm,getX1(),getY1(),getX2(),getY2());
		g.drawLine(p.x - text_width / 2, p.y, p.x + text_width / 2, p.y);
		g.drawLine(p.x - text_width / 2, getY2(), p.x + text_width / 2, getY2());
		g.drawArc(p.x + text_width / 2 - getHeight() / 2, p.y, getHeight(), getHeight(), -90, 180);
		g.drawArc(p.x - text_width / 2 - getHeight() / 2, p.y, getHeight(), getHeight(), 90, 180);
		p.y = getY2();
		if(getLeft() == null || getLeft().isRecursiveEnd())
			return this;
		return getLeft().paint(g, fm, p);
	}

	public int get_variables_width(Graphics g, FontMetrics fm, VariablePanel variablePanel)
	{
		int max_width = 0;
		Rectangle2D rect;
		String var;
		var = variablePanel.getIntVars();
		if(var.length() > 0)
		{
			rect = fm.getStringBounds("整数:"+var, g);
			int w = (int)rect.getWidth();
			if(w > max_width)max_width = w;
		}
		var = variablePanel.getIntVars();
		if(var.length() > 0)
		{
			rect = fm.getStringBounds("実数:"+var, g);
			int w = (int)rect.getWidth();
			if(w > max_width)max_width = w;
		}
		var = variablePanel.getStringVars();
		if(var.length() > 0)
		{
			rect = fm.getStringBounds("文字列:"+var, g);
			int w = (int)rect.getWidth();
			if(w > max_width)max_width = w;
		}
		var = variablePanel.getBooleanVars();
		if(var.length() > 0)
		{
			rect = fm.getStringBounds("真偽:"+var, g);
			int w = (int)rect.getWidth();
			if(w > max_width)max_width = w;
		}
		return max_width;
	}
	public void paint_variables(Graphics g, FontMetrics fm, Point p0, VariablePanel variablePanel) {
		int x = p0.x + text_width / 2 + getHeight();
		int y = p0.y + text_height;
		String var;
		var = variablePanel.getIntVars();
		g.setColor(Color.BLACK);
		if(var.length() > 0)
		{
			g.drawString("整数:"+var, x, y);
			y += text_height;
		}
		var = variablePanel.getFloatVars();
		if(var.length() > 0)
		{
			g.drawString("実数:"+var, x, y);
			y += text_height;
		}
		var = variablePanel.getStringVars();
		if(var.length() > 0)
		{
			g.drawString("文字列:"+var, x, y);
			y += text_height;
		}
		var = variablePanel.getBooleanVars();
		if(var.length() > 0)
		{
			g.drawString("真偽:"+var, x, y);
//			y += text_height;
		}
	}

	@Override
	public void setSize(Graphics g, FontMetrics fm) {
		text_width = text_height = 0;
		if(getText() != null)
		{
			Rectangle2D rect = fm.getStringBounds(getText(), g);
			text_width = (int)rect.getWidth();
			text_height = (int)rect.getHeight();
		}
		if(text_width < size * 6) text_width = size * 6;
		if(text_height < size * 2) text_height = size * 2;

	}

	@Override
	public Parts appendTo(StringBuilder sb, int indentLevel) {
		makeIndent(sb, indentLevel);
		if(getLeft() != null) return getLeft().appendTo(sb, indentLevel);
		return this;
	}

	@Override
	public boolean dispMenu(final Flowchart chart, MouseEvent e)
	{
		return false;
	}

	@Override
	Parts makeXML(Document doc, Element parent) {
		if(left == empty)return this;
		return left.makeXML(doc, parent);
	}
/*
	@Override
	public Parts paintPdf(PdfContentByte cb, int height, Graphics g,
			FontMetrics fm, Point p) {
		setX1(p.x - getWidth() / 2);
		setX2(p.x + getWidth() / 2);
		setY1(p.y);
		setY2(p.y + getHeight());
		g.setColor(Color.WHITE);
		g.fillRect(p.x - text_width / 2, p.y, text_width , getHeight());
		g.fillArc(p.x + text_width / 2 - getHeight() / 2, p.y, getHeight(), getHeight(), -90, 180);
		g.fillArc(p.x - text_width / 2 - getHeight() / 2, p.y, getHeight(), getHeight(), 90, 180);
		g.setColor(Color.BLACK);
		drawStringPdf(cb, height, getText(),g,fm,getX1(),getY1(),getX2(),getY2());
		g.drawLine(p.x - text_width / 2, p.y, p.x + text_width / 2, p.y);
		g.drawLine(p.x - text_width / 2, getY2(), p.x + text_width / 2, getY2());
		g.drawArc(p.x + text_width / 2 - getHeight() / 2, p.y, getHeight(), getHeight(), -90, 180);
		g.drawArc(p.x - text_width / 2 - getHeight() / 2, p.y, getHeight(), getHeight(), 90, 180);
		p.y = getY2();
		if(getLeft() == null || getLeft().isRecursiveEnd())
			return this;
		return getLeft().paintPdf(cb, height, g, fm, p);
	}
*/

}
